﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using com.swivelsecure.pinsafe;

public partial class Reset : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack || !"1".Equals(varCodeRequested.Value))
		{
			// Hide the reset code row if we don't have a username yet.
			trResetCode.Visible = false;
		}
		else
		{
			trResetCode.Visible = true;
		}
	}

	protected void btnReset_Click(object sender, EventArgs e)
	{
		string username = txtUsername.Text;
		string resetCode = txtResetCode.Text;
		if (username == null || "".Equals(username.Trim()))
		{
			// No username found.
			lblResult.Text = "Please enter your username";
		}
		else if ("1".Equals(varCodeRequested.Value))
		{
			// We're expecting a reset code
			if (resetCode == null || "".Equals(resetCode.Trim()))
			{
				// No reset code found.
				lblResult.Text = "Please enter your reset code";
			}
			else
			{
				PINsafeClient client = new PINsafeClient();
				bool result = client.Reset(username, resetCode);
				if (result)
				{
					lblResult.Text = "User self-reset succeeded. Please return to the login page";
				}
				else
				{
					lblResult.Text = "User self-reset failed. Click button to request another code, or contact administrator";
					trResetCode.Visible = false;
					varCodeRequested.Value = "0";
					btnReset.Text = "Request Code";
				}
			}
		}
		else
		{
			// Request a reset code.
			PINsafeClient client = new PINsafeClient();
			bool result = client.RequestResetCode(username);
			if (result)
			{
				trResetCode.Visible = true;
				varCodeRequested.Value = "1";
				btnReset.Text = "Reset";
				txtUsername.ReadOnly = true;
				lblResult.Text = "Reset code requested. Please check your messages";
			}
			else
			{
				lblResult.Text = "Unable to request a reset code";
			}
		}
	}
}
